/**
 * Title: Expert 01 - Experimenting advanced costructors topics
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.expert ;

public class Expert01 {

	// CLASS ATTRIBUTE
	// Do not set default values here: use the constructor or a setState() method.
	int[] dimensions = new int[2] ;

	// FIRST CONSTRUCTOR
	public Expert01() {

		System.out.println("") ;
		System.out.println("Creating the object: " + this) ;
		System.out.println("(Class: " + getClass().getName() + ")") ;
	}

	// SECOND CONSTRUCTOR
	public Expert01(int[] dimensions) {

		// We call this() only to have the same "println()" as above: it is not necessary!
		this() ;
		System.out.println("Now trying to set dimensions values from imput.\n") ;
		this.dimensions[0] = dimensions[0] ;
		this.dimensions[1] = dimensions[1] ;
	}

	// MAIN METHOD
    public static void main(String arg[]) throws Exception {

		// This array will have default value {0,0}
		int[] input = new int[2] ;

		// To write good code following two line should be inside a try{} block !
		if (arg.length > 0) input[0] = Integer.parseInt(arg[0]) ;
		if (arg.length > 1) input[1] = Integer.parseInt(arg[1]) ;

		// Create the two instances of "this" application
		Expert01 first  = new Expert01() ;
		Expert01 second = new Expert01(input) ;

		// Printing the states of the two objects
		first.printState() ;
		second.printState() ;
	}

	// This is not an accessor method, but something like an "introspection" method.
	public void printState() {

		System.out.print("State of " + this + ": ") ;
		System.out.print("(X:" + dimensions[0] + ", ") ;
		System.out.print("Y:" + dimensions[1] + ")\n\n") ;
    }


} // End of class
