/**
 * Title: Expert 03 - Experimenting with casting and helper classes
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.expert ;

public class Expert03 {

	public static void main(String arg[]) throws Exception {

		Expert03 application = new Expert03() ;
		application.populate() ;
	}

	public void populate() {

		Adam  adam 	= new Adam() ;
		Man   man 	= new Man() ;
		Woman temp	= new Woman() ;

		// Creating eva by casting a Woman into an Adam object.
		// After this a real Woman will be obtained by "back casting".
		Adam 	eva = (Adam) temp ;
		Woman woman = (Woman) eva;

		adam.walk() ;
		man.walk() ;
		eva.walk() ;
		woman.walk() ;

		// Showowing that woman can speak even if she "was an Adam for a while"
		System.out.println() ;
		man.speak() ;
		woman.speak() ;

		// Remark: eva is not able to speak, since speak() does not exist in Adam !!!
		//eva.speak() ;

		System.out.println("\nIs eva an instance of Woman? " + (eva instanceof Woman) ) ;
		System.out.println("Is eva an instance of Adam? " + (eva instanceof Adam) ) ;
		System.out.println("Is man an instance of Adam? " + (man instanceof Adam) ) ;
		System.out.println("Is eva an instance of Man? " + (eva instanceof Man) ) ;

		// Remark: this cast is not possible, since man does not extend Woman !!!
		//Woman amanda = (Woman) man ;
	}

} // End of class


// The ADAM class will be the parent for MAN and WOMAN
class Adam {

	public void walk() 		{

		System.out.print(this + " walks like Adam") ;
		System.out.println(" (class: " + getClass().getName() + ")") ;
	}
}


// The MAN class is a child of the ADAM class
class Man extends Adam {

	public void walk() 		{

		System.out.print(this + " walks like a Man") ;
		System.out.println(" (class: " + getClass().getName() + ")") ;
	}

	public void speak() 	{	System.out.println(this + " speaks like a Man") ;	}
}


// The WOMAN class is another child of the ADAM class
class Woman extends Adam {

	public void walk() 		{

		System.out.print(this + " walks like a Womam") ;
		System.out.println(" (class: " + getClass().getName() + ")") ;
	}

	public void speak() 	{	System.out.println(this + " speaks like a Womam") ;	}
}
