/**
 * Title: Expert 05 - Used by Expert04 as the "sample PARENT class" to test access types
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.expert ;

public class Expert05 {

	int				packageInt ;
	public int 		publicInt ;
	private int		privateInt ;
	protected int	protectedInt ;

	// PUBLIC accessible method: every class can print the state (printing is harmless)
	public void printState() {

		System.out.println("\nState of " + this) ;
		System.out.println("packageInt is: "   + packageInt) ;
		System.out.println("publicInt is: "    + publicInt) ;
		System.out.println("privateInt is: "   + privateInt) ;
		System.out.println("protectedInt is: " + protectedInt) ;
	}

	// PROTECTED accessible method
	protected int[] getState() {

		return bundle() ;
	}

	// PACKAGE accessible method
	void setState(int a, int b, int c, int d) {

		this.packageInt = a ;
		this.publicInt = b ;
		this.privateInt = c ;
		this.protectedInt = d ;
	}

	// PRIVATE accessible method: only this class can use it (grating encapsulation)
	private int[] bundle() {

		int[] temp = {packageInt, publicInt, privateInt, protectedInt} ;
		return temp;
	}

} // End of class

