/**
 * Title: Expert 06 - Used by Expert04 as the "sample child class" to test access types
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.expert ;

public class Expert06 extends Expert05 {

	Expert05 myParent = new Expert05() ;

// ********************* TESTING METHODS ***************************

	// Accessing the parent's PUBLIC method: we return 'false' if this code does not compile
	public boolean accessPublicMethod() {
		myParent.printState() ;
		return true ;
	}

	// Using the inherited PUBLIC method: we return 'false' if this code does not compile
	public boolean hasPublicMethod() {
		printState() ;
		super.printState() ;
		return true ;
	}

	// Accessing the parent's PROTECTED method: we return 'false' if this code does not compile
	public boolean accessProtectedMethod() {
		int[] foo = myParent.getState() ;
		return true ;
	}

	// Using the inherited PROTECTED method: we return 'false' if this code does not compile
	public boolean hasProtectedMethod() {
		int[] foo1 = getState() ;
		int[] foo2 = super.getState() ;
		return true ;
	}

	// Accessing the parent's PACKAGE method: we return 'false' if this code does not compile
	public boolean accessPackageMethod() {
		myParent.setState(40,41,42,43) ;
		return true ;
	}

	// Using the inherited PACKAGE method: we return 'false' if this code does not compile
	public boolean hasPackageMethod() {
		setState(50,51,52,53) ;
		super.setState(60,61,62,63) ;
		return true ;
	}

	// Accessing the parent's PRIVATE method: we return 'false' if this code does not compile
	public boolean accessPrivateMethod() {
		//int[] foo = myParent.bundle() ;
		return false ;
	}

	// Using the inherited PRIVATE method: we return 'false' if this code does not compile
	public boolean hasPrivateMethod() {
		//int[] foo1 = bundle() ;
		//int[] foo2 = super.bundle() ;
		return false ;
	}

// ********************* TESTING FIELDS ****************************

	// Trying to access/use the parent's PUBLIC fields (as above)
	public boolean accessPublicField() {
		int foo = myParent.publicInt ;
		return true ;
	}

	public boolean hasPublicField() {
		int foo1 = this.publicInt ;
		int foo2 = super.publicInt ;
		return true ;
	}

	// Trying to access/use the parent's PROTECTED fields (as above)
	public boolean accessProtectedField() {
		int foo = myParent.protectedInt ;
		return true ;
	}

	public boolean hasProtectedField() {
		int foo1 = this.protectedInt ;
		int foo2 = super.protectedInt ;
		return true ;
	}

	// Trying to access/use the parent's PACKAGE fields (as above)
	public boolean accessPackageField() {
		int foo = myParent.packageInt ;
		return true ;
	}

	public boolean hasPackageField() {
		int foo1 = this.packageInt ;
		int foo2 = super.packageInt ;
		return true ;
	}

	// Trying to access/use the parent's PRIVATE fields (as above)
	public boolean accessPrivateField() {
		//int foo = myParent.privateInt ;
		return false ;
	}

	public boolean hasPrivateField() {
		//int foo1 = this.privateInt ;
		//int foo2 = super.privateInt ;
		return false ;
	}

} // End of class

