/**
 * Title: Expert 17 - An applet drawing pictures.
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.expert ;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class Expert17 extends Applet implements ActionListener {

	Image image ;
	boolean show ;
	Button button ;

	// Arguments of the Polygon constructur (see below)
	int[] starX = {100, 130, 140, 150, 180, 160, 170, 140, 110, 120, 100 } ;
	int[] starY = {330, 330, 300, 330, 330, 350, 380, 360, 380, 350, 330 } ;

	// Initializes the applet.
	public void init() {

		this.show = false ;
		// retrieving the image from the folder of the HTML page.
		this.image = getImage(getDocumentBase(), "water.jpg") ;

		this.button = new Button("Show") ;
		setLayout( new BorderLayout() ) ;
		add(button, "North") ;
		button.addActionListener(this) ;
	}

	// Called each time the button "Show" is pressed.
    public void actionPerformed(ActionEvent theEvent) {

		this.show = ! show ;
		repaint() ;
	}

	// Drawing all the pictures.
	public void paint(Graphics graphic) {

		// The empty green round border rectangle
		graphic.setColor(Color.GREEN) ;
		graphic.drawRoundRect(50, 50, 100, 200, 25, 50) ;

		// The filled oval
		graphic.setColor(Color.ORANGE) ;
		graphic.fillOval(250, 100, 200, 100) ;
		graphic.setColor(Color.BLACK) ;
		graphic.drawOval(250, 100, 200, 100) ;

		// The red star
		graphic.setColor(Color.RED) ;
		Polygon theStar = new Polygon(starX, starY, starX.length) ;
		graphic.fillPolygon(theStar) ;

		if (show) graphic.drawImage(image, 300, 50, this) ;
	}

}	// END OF APPLET
