/**
 * Title: Expert 20 - Managing system files.
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.expert ;

import java.io.* ;
import java.awt.* ;
import java.util.* ;

public class Expert20 extends Expert19 {

	// The main method
    public static void main(String args[])    {

		Expert20 theApp = new Expert20() ;
    }


	// Ovverriding the method introduced in Expert19
    public void displayFile(String dirName, String fileName)    {

		// Getting the folder's content
        if (dirName == null) dirName = "." ;
        File fileDir = new File(dirName) ;
        String[] dirList = fileDir.list();

		// Initializing the display (as defined in Expert19)
		theDisplay.setFont(new Font("Courier",Font.PLAIN,12)) ;
		theDisplay.append("\n");
        theDisplay.append("*** Info about the directory " + dirName + " ***\n");

		// Scrolling the results
        for ( int i = 0; i < dirList.length; i++ ) {

			// Writing the file name
            File theFile = new File(fileDir, dirList[i] ) ;
        	theDisplay.append(theFile.getName()) ;

            // Formatting the file name field (variable length)
            int margin = (25 - theFile.getName().length()) ;
            for (int k=0; k < margin; k++) theDisplay.append(" ") ;

			// Showing others data
            theDisplay.append("" + ( theFile.isDirectory() ? "d" : " " ) ) ;
            theDisplay.append("" + ( theFile.isFile()      ? "f" : " " ) ) ;
            theDisplay.append("" + ( theFile.canRead()     ? "r" : " " ) ) ;
            theDisplay.append("" + ( theFile.canWrite()    ? "w" : " " ) ) ;
            theDisplay.append("  " + new Date( theFile.lastModified()) ) ;
            theDisplay.append("  " + theFile.length() + " bytes" ) ;
            theDisplay.append("\n") ;
        }

        theDisplay.append("\n") ;
    }

	// We want to accept everything, in order to open any directory
    public boolean accept(File dir, String name)    {

		return true ;
    }

} // End of class
